<?php

namespace Ems\portalGestor\Controller;

use Ems\portalGestor\Service\TreinamentoService;
use Ems\portalGestor\Util\ExpectedException;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\{ Error, Message };

class TreinamentoController {

    public function __construct(
        TreinamentoService  $treinamentoService
    ) {
        $this->treinamentoService = $treinamentoService;
    }

    public function getCurso(
        Request\Filter $request,
        Response $response
    ) {
        try {
            $row = $request->getParameters();
            $nrOrg = (int) $row['NRORG'];
            $cursos = $this->treinamentoService->getCurso($nrOrg);
            $response->addDataSet(new DataSet('data', $cursos));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode(), $e->getTrace()));
        }
    }

    public function getPerfilAcesso(
        Request\Filter $request,
        Response $response
    ) {
        try {
            $row = $request->getParameters();
            $nrOrg = (int) $row['NRORG'];
            $cursos = $this->treinamentoService->getPerfilAcesso($nrOrg);
            $response->addDataSet(new DataSet('data', $cursos));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode(), $e->getTrace()));
        }
    }

    public function getMetodo(
        Request\Filter $request,
        Response $response
    ) {
        try {
            $row = $request->getParameters();
            $nrOrg = (int) $row['NRORG'];
            $cursos = $this->treinamentoService->getMetodo($nrOrg);
            $response->addDataSet(new DataSet('data', $cursos));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode(), $e->getTrace()));
        }
    }
}
