CREATE OR REPLACE PROCEDURE ARQUIVO_SEF2(
   P_CDIMPOSTO    IN IMPOSTO.CDIMPOSTO%TYPE,
   P_CDEMPRESA    IN EMPRESA.CDEMPRESA%TYPE,
   P_CDINSCESTA   IN EMPRESA.CDINSCESTA%TYPE,
   P_CDINSCMUNI   IN EMPRESA.CDINSCMUNI%TYPE,
   P_DTINICIAL    IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINAL      IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_CDLIVROMAG   IN LIVROMAGNETICO.CDLIVROMAG%TYPE,
   P_SUFRAMA      IN VARCHAR2,
   P_ARQUIVO      IN VARCHAR2,
   P_VERSAO       IN VARCHAR2,
   P_FINALIDADE   IN VARCHAR2,
   P_PRF_RI       IN VARCHAR2,
   P_IND_EC       IN VARCHAR2,
   P_IND_ISS      IN VARCHAR2,
   P_IND_ST       IN VARCHAR2,
   P_IND_AT       IN VARCHAR2,
   P_IND_IPI      IN VARCHAR2,
   P_IND_RI       IN VARCHAR2,
   P_BLOCOH       IN VARCHAR2,
   P_DTINIPER     IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINPER     IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_NRSEQARQMAG  IN ARQMAGNETICO.NRSEQARQMAG%TYPE)
AS
   V_CONTREG0     NUMBER;
   V_CONTREGC_AUX VARCHAR2(20);
   V_CONTREGC     NUMBER;
   V_CONTREGE     NUMBER;
   V_CONTREGF     NUMBER;
   V_CONTREGG     NUMBER;
   V_CONTREGH     NUMBER;
   V_CONTREG9     NUMBER;
   V_TOTSEF2      NUMBER;
   V_TOTALIZA     NUMBER;
   V_MOVBLOCOH    NUMBER;
BEGIN
   V_TOTSEF2 := 0;
   DELETE FROM TMP_REGDADOSSEF2;
   COMMIT;

----------------------------------------------------  /* BLOCO C */   ----------------------------------------------
   IF P_ARQUIVO = '1' THEN
      V_CONTREGC := 0;
      V_CONTREGC_AUX := SEF2_BLOCOC(P_CDIMPOSTO,P_CDEMPRESA,P_CDINSCESTA,P_DTINICIAL,P_DTFINAL,P_IND_IPI,P_NRSEQARQMAG);
      V_CONTREGC := TO_NUMBER(SUBSTR(V_CONTREGC_AUX,1,10));
      V_TOTALIZA := TO_NUMBER(SUBSTR(V_CONTREGC_AUX,10,10));
----------------------------------------------------  /* BLOCO E */   ----------------------------------------------
   ELSIF P_ARQUIVO = '2' THEN
      V_CONTREGE := 0;
      V_CONTREGE := SEF2_BLOCOE (P_CDIMPOSTO,P_CDEMPRESA,P_CDINSCESTA,P_DTINICIAL,P_DTFINAL,P_IND_IPI,P_CDLIVROMAG,P_NRSEQARQMAG);
----------------------------------------------------  /* BLOCO F */   ----------------------------------------------
/*      V_CONTREGE := 0;
      V_CONTREGF := SEF2_BLOCOF (P_CDIMPOSTO,P_CDEMPRESA,P_CDINSCESTA,P_DTINICIAL,P_DTFINAL,P_NRSEQARQMAG);*/
------------------------------------------------------/* BLOCO G  */ -----------------------------------------------
/*      V_CONTREGG:= 0;
      V_CONTREGG:= SEF2_BLOCOG(P_CDEMPRESA,P_CDINSCESTA,P_DTINICIAL,P_DTFINAL,P_CDIMPOSTO,P_NRSEQARQMAG);*/
---------------------------------------------------- /*  BLOCO H  */ -----------------------------------------------
   ELSIF P_ARQUIVO = '3' THEN
      V_CONTREGH := 0;
      V_CONTREGH := SEF2_BLOCOH(P_CDEMPRESA,P_CDINSCESTA,P_DTINICIAL,P_DTFINAL,P_CDLIVROMAG,P_PRF_RI,P_DTINIPER,P_DTFINPER,V_TOTALIZA,P_NRSEQARQMAG,P_IND_IPI,P_IND_ISS,V_MOVBLOCOH);
   END IF;
----------------------------------------------------  /* ABERTURA */  ----------------------------------------------
   V_CONTREG0 := 0;
   V_CONTREG0 := SEF2_BLOCO0(P_CDEMPRESA,P_CDINSCESTA,P_CDINSCMUNI,P_DTINICIAL,P_DTFINAL,P_CDLIVROMAG,P_SUFRAMA,P_ARQUIVO,P_VERSAO,P_FINALIDADE,
                             P_PRF_RI,P_IND_EC,P_IND_ISS,P_IND_ST,P_IND_AT,P_IND_IPI,P_IND_RI,P_DTINIPER,P_DTFINPER,P_NRSEQARQMAG,V_MOVBLOCOH);
----------------------------------------------------  /*  BLOCO 9  */  ---------------------------------------------
   V_CONTREG9 := 0;
   V_CONTREG9 := SEF2_BLOCO9(P_NRSEQARQMAG,V_MOVBLOCOH);
-------------------------------------   /* ENCERRAMENTO TOTAL DO BLOCO */ ---------------------------------------------

   /* total de linhas do arquivo  somado mais um quando insere na tabela para que seja considerado o ultimo registro 9999 */
   BEGIN
      SELECT COUNT(*)
      INTO V_TOTSEF2
      FROM ARQMAGNETICO
      WHERE NRSEQARQMAG = P_NRSEQARQMAG;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_TOTSEF2 := 0;
   END;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('999'||LPAD(RTRIM(V_CONTREG9), 7, '0'), '|9999'|| '|' ||RTRIM(V_TOTSEF2+1)|| '|',  P_NRSEQARQMAG);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ARQUIVO_SEF2','0.00.000'); END;
/