/*
NOME: 0011_CARSTPO_USR_IMPORTA_AJUSTEESTOQUE.SQL
DESCRIO: Procedimento para importao do ajuste de estoque
CRIAO: 20/03/2012 - Marcelo Alexsandro Souza Silva
*/

CREATE OR REPLACE PROCEDURE USR_IMPORTA_AJUSTEESTOQUE AS
   V_DTGRV         DATE;
   V_HRGRV         VARCHAR2(04);
   V_NRSEQUITEM    NUMBER := 0;
   V_NRLANCESTQ    VARCHAR2(20);
   V_CDOPERADOR    VARCHAR2(12);
   V_COUNT         NUMBER := 0;
   V_RETURN        VARCHAR2(1);
   V_ERROR VARCHAR2(4000);
BEGIN
   V_RETURN := USR_FUNC_BLOQUEIO('USR_POSICAOESTOQUE', 'B');
   IF V_RETURN = 'S' THEN
      V_CDOPERADOR := '000000092420';
      SELECT COUNT(1)
       INTO V_COUNT
       FROM OPERADOR
      WHERE CDOPERADOR = V_CDOPERADOR;
      IF (NOT (V_COUNT > 0)) THEN
         SELECT MAX(CDOPERADOR)
           INTO V_CDOPERADOR
           FROM OPERADOR;
      END IF;

      V_DTGRV := NULL;
      V_HRGRV := NULL;


      /* Retorna data e hora de exportao */
      BEGIN
        SELECT TO_DATE(SYSDATE), TO_CHAR(SYSDATE,'HH24MI')
        INTO V_DTGRV, V_HRGRV
        FROM DUAL;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           V_DTGRV := NULL;
           V_HRGRV := NULL;
      END;

      FOR C_FILIAL IN
        (SELECT CDFILIAL
           FROM FILGRUPFILI
          WHERE FILGRUPFILI.CDGRUPFILI = '9999999999')
      LOOP
        V_NRSEQUITEM := 1;
        /* Verificao dos ajustes de estoque a serem importados */
        FOR C_MOVESTO IN
           (SELECT USR_POSICAOESTOQUE.CDFILIAL, PRODUTO.CDPRODUTO, USR_POSICAOESTOQUE.DATAPOSICAO, USR_POSICAOESTOQUE.QTDEPOSICAO, USR_POSICAOESTOQUE.VRCUSTPOSICAO, PRODUTO.CDARVPROD
              FROM USR_POSICAOESTOQUE, PRODUTO
             WHERE IDORIGREGISTRO = 'P'
               AND DTIMPORTACAO IS NULL
               AND HRIMPORTACAO IS NULL
               AND DTGRAVACAO IS NOT NULL
               AND HRGRAVACAO IS NOT NULL
               AND PRODUTO.CDPRODUTO = PRODUTO.CDPRODESTO
               AND USR_POSICAOESTOQUE.CDPRODUTO = PRODUTO.CDARVPROD
               AND CDFILIAL = C_FILIAL.CDFILIAL
            )
        LOOP
           IF V_NRSEQUITEM = 1 THEN
              NOVO_CODIGO('LANCTOEST' || '0070', V_NRLANCESTQ);
              INSERT INTO LANCTOESTOQ
              (CDFILIAL,NRLANCESTQ,CDOPERADOR,IDTPLANCTO,DTLANCESTQ,CDFILIMOVI, DSLANCESTQ)
              VALUES
              ('0070', SUBSTR(V_NRLANCESTQ,11,10), V_CDOPERADOR, '1', C_MOVESTO.DATAPOSICAO, C_MOVESTO.CDFILIAL, 'Interface Portal WEB');
           END IF;
           INSERT INTO ITLANCTOEST
              (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO,
               QTTOTLANCTO, VRUNILANCTO, VRTOTLANCTO, IDTIPOMOVI,
               DTLANCMOVI, IDORDEMCLC, CDPRODMOVI, QTLANCTOEST,
               VRLANCTOBRUT, VRLANCTOEST, CDFILIMOVI, IDEVOLESTOQ,
               CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDOPERADOR)
           VALUES
              ('0070', SUBSTR(V_NRLANCESTQ,11,10), LPAD(TO_CHAR(V_NRSEQUITEM), 4, '0'), C_MOVESTO.CDPRODUTO,
               C_MOVESTO.QTDEPOSICAO, 0, 0, '1',
               C_MOVESTO.DATAPOSICAO, 'U', C_MOVESTO.CDPRODUTO, C_MOVESTO.QTDEPOSICAO,
               0, 0, C_MOVESTO.CDFILIAL, 'S',
               ' ', ' ', ' ', ' ', V_CDOPERADOR);
           UPDATE USR_POSICAOESTOQUE
              SET DTIMPORTACAO = V_DTGRV,
                  HRIMPORTACAO = V_HRGRV
            WHERE CDFILIAL = C_MOVESTO.CDFILIAL
              AND CDPRODUTO = C_MOVESTO.CDARVPROD
              AND DATAPOSICAO = C_MOVESTO.DATAPOSICAO;
           V_NRSEQUITEM := V_NRSEQUITEM + 1;
        END LOOP;
        COMMIT;
      END LOOP;
      V_RETURN := USR_FUNC_BLOQUEIO('USR_POSICAOESTOQUE', 'D');
   END IF;
EXCEPTION
  WHEN OTHERS THEN BEGIN
     IF V_RETURN = 'S' THEN
        V_ERROR:= SQLERRM(SQLCODE);
        V_RETURN := USR_FUNC_BLOQUEIO('USR_POSICAOESTOQUE', 'D', V_ERROR);
     END IF;
  END;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_IMPORTA_AJUSTEESTOQUE','5.09.xxx'); END;
/
